"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.
"
"{ Package: 'stx:libjava' }"

JavaNode subclass:#JavaMethodNode
	instanceVariableNames:'modifiers type declarator startPosition javadoc'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-AST'
!

!JavaMethodNode class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.

"
! !

!JavaMethodNode methodsFor:'accessing'!

declarator
    ^ declarator
!

declarator:something
    declarator := something.
!

javadoc
    ^ javadoc
!

javadoc:something
    javadoc := something.
!

modifiers
    ^ modifiers
!

modifiers:something
    modifiers := something.
!

selector
    | name |
"/    self halt: 'does not work properly ;('.
    name := self declarator identifier.
    name := name, '('.
    name := name, (self declarator parameterSelector).
    name := name, ')', (self type selector).

    ^name.

    "Created: / 13-12-2010 / 14:35:06 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 17-12-2010 / 17:47:10 / Jan Kurs <kurs.jan@post.cz>"
!

startPosition
    startPosition ifNil: [ startPosition := self determineStartPosition. ].
    ^ startPosition

    "Modified: / 13-12-2010 / 10:35:47 / Jan Kurs <kurs.jan@post.cz>"
!

type
    ^ type
!

type:something
    type := something.
! !

!JavaMethodNode methodsFor:'printing & storing'!

printOn:aStream
    aStream nextPutAll: self selector.

    "Created: / 17-12-2010 / 17:38:20 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaMethodNode methodsFor:'private'!

determineStartPosition
    self javadoc ifNotNil: [ ^ self javadoc lineNumber].
    (self modifiers size > 0) ifTrue:[
        ^ self modifiers first lineNumber
    ].
    ^ self type lineNumber.

    "Created: / 13-12-2010 / 10:34:01 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 17-12-2010 / 18:19:30 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaMethodNode methodsFor:'queries'!

isMethodDeclaration
    ^ true.

    "Created: / 13-12-2010 / 14:34:14 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaMethodNode class methodsFor:'documentation'!

version_SVN
    ^ '$Id: JavaMethodNode.st,v 1.1 2011-08-18 19:06:53 vrany Exp $'
! !
